import { useEffect, useRef, useState } from 'react'
import HeaderFilter from './components/HeaderFilter'
import ContentTable from './components/ContentTable'
import CreateModal from './components/CreateModal'
import type { 
  RowDataType, PaginationParamsType 
} from './components/ContentTable/types'
import { useGlobalStateUpdate } from '@src/store/globalStates/loadingState'
import { RefType, FormDataType } from './components/CreateModal/types'


export function AppManage(){
  const [tableData, setTableData] = useState<RowDataType[]>([])
  const [total, setTotal] = useState(0)
  const [paginationParams, setPaginationParams] = useState<PaginationParamsType>({ pageNumber: 1, pageSize: 10})
  const createModalRef = useRef<RefType>()
  const setloading = useGlobalStateUpdate()

  useEffect(()=>{
    getTableData()   
  },[paginationParams])

  const  getTableData = async () => {
    // TODO 获取数据

    // setloading(true)
    // const data = await getPlanList(mergeRequestParams(paginationParams, filterParams))
    // if (data) {
    //   setTableData(data.objs)
    //   setTotal(data.totalSize)
    // }
    // setloading(false)
  }

  const onPaginationChange =async (params: PaginationParamsType) => {
    setPaginationParams(params)
  }

  const onCreate = () => {
    createModalRef.current?.open()
  }

  const editRow = (row: RowDataType) => {
    createModalRef.current?.open(row)
  }

  const deleteRow = async (row: RowDataType) => {
    // TODO 删除
  }

  const createApp = (form: FormDataType, cb:EventFunctionType<[]>) => {
    console.log('创建',form)
    // TODO 创建接口
    cb()
  }

  const updateApp = (form: RowDataType,  cb:EventFunctionType<[]>) => {
    console.log('更新',form)
    // TODO 更新接口
    cb()
  }

  return (
    <>
      <HeaderFilter onCreate={onCreate} />
      <ContentTable 
        total={ total } 
        pageNumber={ paginationParams.pageNumber }
        pageSize={ paginationParams.pageSize }
        tableData={ tableData } 
        onPaginationChange = { onPaginationChange }
        onEditRow={ editRow } 
        onDeleteRow={ deleteRow }
      />
      <CreateModal 
        ref={createModalRef}
        onCreate={createApp}
        onUpdate={updateApp}
      />
    </>
  )
}
